#ifndef _FIND_IN_FILES_PLUGIN_H_
#define _FIND_IN_FILES_PLUGIN_H_

class QTreeWidgetItem;

#include <QtCore/QObject>

#include "juffed/JuffPlugin.h"

class FindInFilesPlugin : public QObject, public JuffPlugin {
Q_OBJECT
Q_INTERFACES(JuffPlugin)
public:
	FindInFilesPlugin();
	virtual ~FindInFilesPlugin();

	//	plugin name
	virtual QString name() const;
	//	plugin description
	virtual QString description() const;
	//	engines
	virtual QString targetEngine() const;

	//	controls
	//	plugin toolbar
	virtual QToolBar* toolBar() const;
	//	widget that will be put to dock
	virtual QWidgetList dockList() const;
	virtual Juff::ActionList mainMenuActions(Juff::MenuID) const;

private slots:
	void slotSearchInFiles();
	void slotStopSearch();
	void slotAdvSearch();
	void slotItemDoubleClicked(QTreeWidgetItem*, int);
	void slotMatchFound(const QString, int, int, const QString&);
	void onStarted();
	void onFinished();

private:
	void startSearch();
	void findInFiles(const QString& findText, const QStringList&);
	void findInDir(const QString& findText, const QString&);
	void findInText(const QString& findText, const QString& text, const QString& fileName);
	void showDock();

	class PluginInterior;
	PluginInterior* pInt_;
};

#endif
