#ifndef __FIND_WORKER_H__
#define __FIND_WORKER_H__

#include <QtCore/QThread>

class FindWorker : public QThread {
Q_OBJECT
public:
	struct Params {
		Params(const QString& text = "", const QString& dir = "", bool rec = false) {
			findText = text;
			startDir = dir;
			recursive = rec;
		}
		QString findText;
		QString startDir;
		bool recursive;
	};
	
	FindWorker();

	void setParams(const Params&);
	virtual void run();

signals:
	void matchFound(const QString&, int, int, const QString&);
	
private:
	void findInDir(const QString& findText, const QString& dirName);
	void findInText(const QString& findText, const QString& text, const QString& fileName);

	Params params_;
};

#endif /* __FIND_WORKER_H__ */
