#include <QDebug>

#include "SearchDlg.h"

#include <QtGui/QCompleter>
#include <QtGui/QFileDialog>

SearchDlg::SearchDlg(QWidget* parent) : QDialog(parent) {
	ui.setupUi(this);
	
	model_.setSorting(QDir::DirsFirst);
	ui.dirEd->setCompleter(new QCompleter(&model_));
	
	connect(ui.browseBtn, SIGNAL(clicked()), SLOT(slotBrowse()));
}

void SearchDlg::slotBrowse() {
	QString dir = ui.dirEd->text();
	dir = QFileDialog::getExistingDirectory(parentWidget(), tr("Browse"), dir);
	if ( !dir.isEmpty() )
		ui.dirEd->setText(dir);
}


// getters

QString SearchDlg::findText() const {
	return ui.findEd->text();
}
bool SearchDlg::searchInFiles() const {
	return ui.findInFilesBtn->isChecked();
}
QString SearchDlg::startDir() const {
	return ui.dirEd->text();
}
bool SearchDlg::recursive() const {
	return ui.recursiveChk->isChecked();
}


// setters

void SearchDlg::setFindText(const QString& text) {
	ui.findEd->setText(text);
}
void SearchDlg::setStartDir(const QString& dir) {
	ui.dirEd->setText(dir);
}
void SearchDlg::setSearchInFiles(bool inFiles) {
	if ( inFiles )
		ui.findInFilesBtn->setChecked(true);
	else
		ui.findInDirBtn->setChecked(true);
}
void SearchDlg::setRecursive(bool rec) {
	ui.recursiveChk->setChecked(rec);
}
