#ifndef _FM_PLUGIN_H_
#define _FM_PLUGIN_H_

class QLineEdit;
class QPushButton;
class TreeView;

#include <QtCore>
#include <QtCore/QObject>
#include <QtCore/QStack>
#include <QtGui/QDirModel>

#include <juffed/JuffPlugin.h>

class FMPlugin : public QObject, public JuffPlugin {
Q_OBJECT
Q_INTERFACES(JuffPlugin)
public:
	FMPlugin();
	virtual ~FMPlugin();

	//	info
	virtual QString name() const;
	virtual QString description() const;
	virtual QString targetEngine() const;

	//	controls
	virtual QWidgetList dockList() const;

	virtual void applySettings();

protected:
	virtual void onDocSaved(const QString&);

protected slots:
	void itemDoubleClicked(const QModelIndex&);
	void home();
	void up();
	void back();
	void currentDir();
	void favorites();
	void newDir();
	void addToFavorites();
	void goToFavorite();
	void manageFavorites();
	void textEntered();

private:
	void cd(const QString&, bool addToHistory = true);
	void initFavoritesMenu();

	QWidget* w_;
	TreeView* tree_;
	QDirModel model_;
	QLineEdit* pathEd_;
	QPushButton* backBtn_;
	QPushButton* upBtn_;
	QPushButton* homeBtn_;
	QPushButton* currentBtn_;
	QPushButton* refreshBtn_;
	QPushButton* favoritesBtn_;
	QPushButton* newDirBtn_;
	QStack<QString> history_;
	QStringList favorites_;
	QMenu* favoritesMenu_;
	QAction* addToFavoritesAct_;
	QAction* manageFavoritesAct_;
};

#endif
